;
;  PCE CDROM access routines' sources
;

	.include "cdrom.inc"

;	.bss

	.code

;
; cd_reset()
; ----
; Reset CDROM
; ----
;
_cd_reset:
		jsr	cd_reset
		tax
		cla
		rts

;
; cd_pause()
; ----
; Pause CDROM drive
; ----
;
_cd_pause:
		jsr	cd_pause
		tax
		cla
		rts


;
; cd_fade()
; ----
; Fade-out PCM/ADPCM audio
; ----
;
_cd_fade:
		txa
		rts

;
; cd_playtrk(int start_track, int end_track, int mode)
; ----
; Play CDROM audio track
; ----
;

;
; NOTE: TRACK # ARGUMENT SHOULD BE BCD, NOT BINARY !!!!
;
_cd_playtrk:
		txa
		and	#CD_PLAYMODE
		ora	#CD_TRACK
		sta	<_dh		; end type + play mode
		lda	#CD_TRACK
		sta	<_bh		; start type
		
	        lda	[__sp]		; track #
		bne	.endtrk
.endofdisc:
		lda	<_dh		; repeat to end of disc
		ora	#CD_LEADOUT
		sta	<_dh
		bra	.starttrk
.endtrk:
		sta	<_cl		; end track
		stz	<_ch
		stz	<_dl

.starttrk:	ldy	#2
	        lda	[__sp],Y	; track #
		sta	<_al		; from track
		stz	<_ah
		stz	<_bl
		addw	#4,<__sp
		jsr	cd_play
		tax
		cla
		rts

;--------------------
; NOT IMPLEMENTED YET
;--------------------
;
;
; cd_contnts()
; ----
; Get CDROM table of contents
; ----
;
;_cd_contnts:
;		rts
;
;
; cd_seek()
; ----
; Seek CDROM drive
; ----
;
;_cd_seek:
;		rts
;
;
; cd_read()
; ----
; Read from CDROM
; ----
;
;_cd_read:
;		rts
;
;
; cd_stat()
; ----
; Get CDROM status
; ----
;
;_cd_stat:
;		rts
;
;
; cd_playmsf(start_min, start_sec, start_frame
;            [, end_min, end_sec, end_frame [, mode]])
; ----
; Play CDROM audio track
; ----
;
;_cd_playmsf:
;		rts
;--------------------

;
; ex_getver()
; ----
; get CDROM system card version number
; ----
;
_cd_getver:
		jsr	ex_getver
		tya
		sax
		rts


